LVCONVERT(8)

NAME
lvconvert - convert a logical volume from linear to mirror or snapshot

SYNOPSIS
lvconvert -m|--mirrors Mirrors [--mirrorlog {disk|core|mirrored}] [--corelog] [-R|--regionsize MirrorLogRegionSize] [--type SegmentType] [-A|--alloc AllocationPolicy] [-b|--background] [-f|--force] [-i|--interval Seconds] [-h|-?|--help] [--stripes Stripes [-I|--stripesize StripeSize]] [--noudevsync] [-v|--verbose] [-y|--yes] [--version]
LogicalVolume[Path] [PhysicalVolume[Path][:PE[-PE]]...]
lvconvert --splitmirrors Images [--name SplitLogicalVolumeName] [--trackchanges]
MirrorLogicalVolume[Path] [SplittablePhysicalVolume[Path][:PE[-PE]]...]
lvconvert -s|--snapshot [-c|--chunksize ChunkSize] [-h|-?|--help] [--noudevsync] [-v|--verbose] [-Z|--zero y|n] [--version]
OriginalLogicalVolume[Path] SnapshotLogicalVolume[Path]
lvconvert --merge [-b|--background] [-i|--interval Seconds] [-h|-?|--help] [-v|--verbose] [--version] LogicalVolume[Path]...
lvconvert --repair [-h|-?|--help] [-v|--verbose] [--version] LogicalVolume[Path] [PhysicalVolume[Path]...]
lvconvert --replace PhysicalVolume [-h|-?|--help] [-v|--verbose] [--version] LogicalVolume[Path] [PhysicalVolume[Path]...]

DESCRIPTION
lvconvert is used to change the segment type (i.e. linear, mirror, etc) or characteristics of a logical volume. For example, it can add or remove the redundant images of a logical volume, change the log type of a mirror, or designate a logical volume as a snapshot repository.
If the conversion requires allocation of physical extents (for example, when converting from linear to mirror) and you specify one or more PhysicalVolumes (optionally with ranges of physical extents), allocation of physical extents will be restricted to these physical extents. If the conversion frees physical extents (for example, when converting from a mirror to a linear, or reducing mirror legs) and you specify one or more PhysicalVolumes, the freed extents come first from the specified PhysicalVolumes.

OPTIONS
See lvm for common options.
Exactly one of --splitmirrors, --mirrors, --repair, --snapshot or --merge arguments is required.

-m, --mirrors Mirrors
    Specifies the degree of the mirror you wish to create. For example, "-m 1" would convert the original logical volume to a mirror volume with 2-sides; that is, a linear volume plus one copy.

--mirrorlog {disk|core|mirrored}
    Specifies the type of log to use. The default is disk, which is persistent and requires a small amount of storage space, usually on a separate device from the data being mirrored. Core may be useful for short-lived mirrors: It means the mirror is regenerated by copying the data from the first device again every time the device is activated - perhaps, for example, after every reboot. Using "mirrored" will create a persistent log that is itself mirrored.

--corelog
    The optional argument "--corelog" is the same as specifying "--mirrorlog core".

-R, --regionsize MirrorLogRegionSize
    A mirror is divided into regions of this size (in MB), and the mirror log uses this granularity to track which regions are in sync.

--type SegmentType
    Used to convert a logical volume to another segment type or to explicitly state the desired RAID1 segment type ("mirror" or "raid1") when converting a linear logical volume to a mirror with the '-m' argument.

-b, --background
    Run the daemon in the background.

-i, --interval Seconds
    Report progress as a percentage at regular intervals.

--noudevsync
    Disable udev synchronisation. The process will not wait for notification from udev. It will continue irrespective of any possible udev processing in the background. You should only use this if udev is not running or has rules that ignore the devices LVM2 creates.

--splitmirrors Images
    The number of redundant Images of a mirror to be split off and used to form a new logical volume. A name must be supplied for the newly-split-off logical volume using the --name argument, unless the --trackchanges argument is given.

-n Name
    The name to apply to a logical volume which has been split off from a mirror logical volume.

--trackchanges
    Used with --splitmirrors on a raid1 device, this tracks changes so that the read-only detached image can be merged efficiently back into the mirror later. Only the regions of the detatched device where the data changed get resynchronized. Please note that this feature is only supported with the new md-based mirror implementation and not with the original device-mapper mirror implementation.

-s, --snapshot
    Create a snapshot from existing logical volume using another existing logical volume as its origin.

-c, --chunksize ChunkSize
    Power of 2 chunk size for the snapshot logical volume between 4k and 512k.

-Z, --zero y|n
    Controls zeroing of the first KB of data in the snapshot. If the volume is read-only the snapshot will not be zeroed.

--merge
    Merges a snapshot into its origin volume or merges a raid1 image that has been split from its mirror with --trackchanges back into its mirror. To check if your kernel supports the snapshot merge feature, look for 'snapshot-merge' in the output of 'dmsetup targets'. If both the origin and snapshot volume are not open the merge will start immediately. Otherwise, the merge will start the first time either the origin or snapshot are activated and both are closed. Merging a snapshot into an origin that cannot be closed, for example a root filesystem, is deferred until the next time the origin volume is activated. When merging starts, the resulting logical volume will have the origin's name, minor number and UUID. While the merge is in progress, reads or writes to the origin appear as they were directed to the snapshot being merged. When the merge finishes, the merged snapshot is removed. Multiple snapshots may be specified on the commandline or a @tag may be used to specify multiple snapshots be merged to their respective origin.

--repair
    Repair a mirror after suffering a disk failure. The mirror will be brought back into a consistent state. By default, the original number of mirrors will be restored if possible. Specify -y on the command line to skip the prompts. Use -f if you do not want any replacement. Additionally, you may use --use-policies to use the device replacement policy specified in lvm.conf, viz. activation/mirror_log_fault_policy or activation/mirror_device_fault_policy.

--replace PhysicalVolume
    Remove the specified device (PhysicalVolume) and replace it with one that is available in the volume group or from the specific list provided. This option is only available to RAID segment types (e.g. "raid1", "raid5", etc).

Examples
"lvconvert -m1 vg00/lvol1"
converts the linear logical volume "vg00/lvol1" to a two-way mirror logical volume.

Examples
"lvconvert --type raid1 -m1 vg00/lvol1"
converts the linear logical volume "vg00/lvol1" to a two-way RAID1 logical volume. "lvconvert --mirrorlog core vg00/lvol1"
converts a mirror with a disk log to a mirror with an in-memory log. "lvconvert --mirrorlog disk vg00/lvol1"
converts a mirror with an in-memory log to a mirror with a disk log. "lvconvert -m0 vg00/lvol1"
converts a mirror logical volume to a linear logical volume.
"lvconvert --type raid1 vg00/mirror_lv"
converts a mirror logical volume to a RAID1 logical volume with the same number of images.
"lvconvert -s vg00/lvol1 vg00/lvol2"
converts logical volume "vg00/lvol2" to snapshot of original volume "vg00/lvol1"
"lvconvert -m1 vg00/lvol1 /dev/sda:0-15 /dev/sdb:0-15"
converts linear logical volume "vg00/lvol1" to a two-way mirror, using physical extents /dev/sda:0-15 and /dev/sdb:0-15 for allocation of new extents.
"lvconvert -m0 vg00/lvmirror1 /dev/sda"
converts mirror logical volume "vg00/lvmirror1" to linear, freeing physical extents from /dev/sda.
"lvconvert --merge vg00/lvol1_snap"
merges "vg00/lvol1_snap" into its origin.
"lvconvert --merge @some_tag"
If vg00/lvol1, vg00/lvol2, and vg00/lvol3 are all tagged with "some_tag" each snapshot logical volume will be merged serially, e.g.: vg00/lvol1, then vg00/lvol2, then vg00/lvol3. If --background were used it would start all snapshot logical volume merges in parallel.
"lvconvert --splitmirrors 1 --name lv_split vg00/lvmirror1"
Extract one image from the mirror, making it a new logical volume named "lv_split". The mirror the image is extracted from is reduced accordingly. If it was a 2-way mirror (created with '-m 1'), then the resulting original volume will be linear.
"lvconvert --splitmirrors 1 --trackchanges vg00/lv_raid1"
A mirrored logical volume created with --type raid1 can use the '--trackchanges' argument when splitting off an image. Detach one image from the mirrored logical volume lv_raid1 as a separate read-only device and track the changes made to the mirror while it is detached. The split-off device has a name of the form lv_raid1_rimage_N, where N is a number, and it cannot be renamed.
"lvconvert --merge vg00/lv_raid1_rimage_1"
Merge an image that was detached temporarily from its mirror with the '--trackchanges' argument back into its original mirror and bring its contents back up-to-date.
"lvconvert --replace /dev/sdb1 vg00/my_raid1 /dev/sdf1"
Replace the physical volume "/dev/sdb1" in the RAID1 logical volume "my_raid1" with the specified physical volume "/dev/sdf1". Had the argument "/dev/sdf1" been left out, lvconvert would attempt to find a suitable device from those available in the volume group.

SEE ALSO
lvm(8), vgcreate(8), lvremove(8), lvrename(8), lvextend(8), lvreduce(8), lvdisplay(8), lvscan(8)